//==============================================
//      File main.pas
//
//      Components library for Delphi and BCB++.
//         .
//      Demo project main module.
//
//      Copyright 1998-2002 Polaris Software
//      http://polesoft.da.ru
//      mailto: PolarisLib@mail.ru
//==============================================
unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, rLabel, RxCombos, ToolWin, rMenuBar,
  Menus, ActnList, About, ErrorMes, AppEvnts, rUtils, rVCLUtils, rPgSetup,
  Buttons, rButtons, rAction, ImgList, DBCtrls, rLocateDlg, Launch, Db,
  Grids, DBGrids, RXDBCtrl, rDBGrid, rBkgnd, Backgrnd, DictItem, DBrBitBtn,
  Mask, rDBEdit, DBTables, ExtDlgs, rDBConnect, rDBUtils, rBDEUtils, DBMore,
  rSpeedButton, DBrSpeedButton, ToolEdit, rPeriod, rDLLloader, rDBTreeView,
  DBStaticText, CurrEdit, RXSpin, rClasses, rComboEdit, RXCtrls, rCRecGrd,
  rRecGrid, rGraph, rConnect, rPlugins, rPlugSet, DM, rPeriodDlg, rPeriodComboEdit;

type
  TForm1 = class(TForm)
    PCMain: TPageControl;
    TSrLabel: TTabSheet;
    rLabel1: TrLabel;
    RGAlignment: TRadioGroup;
    RGBevelInner: TRadioGroup;
    RGBevelOuter: TRadioGroup;
    GBBlink: TGroupBox;
    CBBlink: TCheckBox;
    Label1: TLabel;
    ECaption: TMemo;
    Label2: TLabel;
    CCBBottomColor: TColorComboBox;
    Label3: TLabel;
    CCBBlinkColor: TColorComboBox;
    Label4: TLabel;
    SESpeed: TRxSpinEdit;
    CCBTopColor: TColorComboBox;
    Label5: TLabel;
    CBTransparent: TCheckBox;
    CBBorderTransparent: TCheckBox;
    Label6: TLabel;
    SEBorderWidth: TRxSpinEdit;
    Label7: TLabel;
    SEBevelWidth: TRxSpinEdit;
    Label8: TLabel;
    CCBColor: TColorComboBox;
    RGLayout: TRadioGroup;
    GBTop: TGroupBox;
    CBTop: TCheckBox;
    Label9: TLabel;
    CCBRTC: TColorComboBox;
    Label10: TLabel;
    SERTD: TRxSpinEdit;
    GroupBox1: TGroupBox;
    Label11: TLabel;
    Label12: TLabel;
    CBBottom: TCheckBox;
    CCBRBC: TColorComboBox;
    SERBD: TRxSpinEdit;
    CBTrans: TCheckBox;
    CBWW: TCheckBox;
    BFont: TrBitBtn;
    FD: TFontDialog;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    Component1: TMenuItem;
    Help1: TMenuItem;
    ControlBar1: TControlBar;
    rMenuBar1: TrMenuBar;
    Exit1: TMenuItem;
    ActionList1: TActionList;
    About1: TMenuItem;
    ErrorHandler1: TErrorHandler;
    rPageSetupDialog1: TrPageSetupDialog;
    N2: TMenuItem;
    TrPageSetupDialog1: TMenuItem;
    TrLabel1: TMenuItem;
    N3: TMenuItem;
    TSOther: TTabSheet;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    AInsert: TrDBActions;
    AEdit: TrDBActions;
    ADelete: TrDBActions;
    ARefresh: TrDBActions;
    AFirst: TrDBActions;
    ALast: TrDBActions;
    Edit1: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N11: TMenuItem;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ILMenu: TImageList;
    N10: TMenuItem;
    Find1: TMenuItem;
    FindNext1: TMenuItem;
    ToolButton8: TToolButton;
    AFind: TrDBActions;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    AFindNext: TrDBActions;
    rLocateDlg1: TrLocateDlg;
    Launcher1: TLauncher;
    TSData: TTabSheet;
    DSGrid: TDataSource;
    Panel1: TPanel;
    CBGAutoSize: TCheckBox;
    CBGAutoWidth: TCheckBox;
    Label13: TLabel;
    SEDefRowHeight: TRxSpinEdit;
    CBGRowSizing: TCheckBox;
    CBGMultiline: TCheckBox;
    Button1: TButton;
    CBGDispBool: TCheckBox;
    CBGDispImages: TCheckBox;
    CBGDispMemo: TCheckBox;
    TrBackground1: TMenuItem;
    rBackground1: TrBackground;
    ToolButton11: TToolButton;
    AView: TrDBActions;
    TreeView1: TTreeView;
    Splitter1: TSplitter;
    DictionaryMgr1: TDictionaryMgr;
    DictionaryItem1: TDictionaryItem;
    DictionaryItem2: TDictionaryItem;
    Panel2: TPanel;
    rDBEdit1: TrDBEdit;
    Label14: TLabel;
    DBrBitBtn1: TDBrBitBtn;
    DBrBitBtn2: TDBrBitBtn;
    TrDBGrid1: TMenuItem;
    PopupMenu1: TPopupMenu;
    Insert1: TMenuItem;
    MenuItem1: TMenuItem;
    View1: TMenuItem;
    MenuItem2: TMenuItem;
    Delete1: TMenuItem;
    N99: TMenuItem;
    Refresh1: TMenuItem;
    N100: TMenuItem;
    Setup1: TMenuItem;
    ILTree: TImageList;
    DictionaryItem3: TDictionaryItem;
    CBEditing: TCheckBox;
    TSErrorHandler: TTabSheet;
    Label15: TLabel;
    CBStyle: TComboBox;
    Label16: TLabel;
    EMessage: TEdit;
    Label17: TLabel;
    Button2: TButton;
    Panel3: TPanel;
    Image1: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    Label18: TLabel;
    ETitleMessage: TEdit;
    Label19: TLabel;
    EUserName: TEdit;
    EHCaption: TEdit;
    Label20: TLabel;
    Label21: TLabel;
    EExtBtnCaption: TEdit;
    Label22: TLabel;
    CBEBVisible: TComboBox;
    RGExcept: TRadioGroup;
    Button3: TButton;
    Label23: TLabel;
    EIniFile: TEdit;
    Label24: TLabel;
    CBIniLoc: TComboBox;
    Label25: TLabel;
    ELogFile: TEdit;
    Label26: TLabel;
    CBLogLoc: TComboBox;
    CBSaveLog: TCheckBox;
    CBShowForm: TCheckBox;
    Label27: TLabel;
    MDesc: TMemo;
    TErrorHandler1: TMenuItem;
    TSLaunch: TTabSheet;
    TSBDE: TTabSheet;
    TLauncher1: TMenuItem;
    TrCloneTableTrDBConnect1: TMenuItem;
    T1: TMenuItem;
    TrButtons1: TMenuItem;
    TSButtons: TTabSheet;
    GroupBox2: TGroupBox;
    Label28: TLabel;
    EAlias: TComboBox;
    CBAlias: TCheckBox;
    Label29: TLabel;
    EUser: TEdit;
    CBUser: TCheckBox;
    Label30: TLabel;
    EPassword: TEdit;
    Label31: TLabel;
    EDrivers: TComboBox;
    CBAutoLogon: TCheckBox;
    Label32: TLabel;
    SEMaxAtt: TRxSpinEdit;
    Button4: TButton;
    GroupBox3: TGroupBox;
    CBTable: TComboBox;
    DBGrid1: TrDBGrid;
    DBGrid2: TrDBGrid;
    rBitBtn1: TrBitBtn;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    EFilter: TrComboEdit;
    DSCloneSrc: TDataSource;
    DSClone: TDataSource;
    ATest: TrDBActions;
    DBBBTest: TDBrBitBtn;
    DBABTest: TButton;
    DBGrid3: TrDBGrid;
    Label36: TLabel;
    Button6: TButton;
    Label37: TLabel;
    DBNULLSBTest: TDBNULLSpeedButton;
    DBNULLBBTest: TDBNULLButton;
    DBEditTest: TDBEdit;
    Label38: TLabel;
    LTest: TLabel;
    GBNeg: TGroupBox;
    GBPos: TGroupBox;
    Label39: TLabel;
    Bevel1: TBevel;
    CBKindAction: TComboBox;
    CBNFirst: TCheckBox;
    CBNLast: TCheckBox;
    CBNEmpty: TCheckBox;
    CBNCanModify: TCheckBox;
    Label40: TLabel;
    Label41: TLabel;
    Label42: TLabel;
    DBSBTest: TDBrSpeedButton;
    CBNInserting: TCheckBox;
    CBNModifying: TCheckBox;
    CBNEditing: TCheckBox;
    CBNAfterEditAssigned: TCheckBox;
    CBNNULL: TCheckBox;
    Label43: TLabel;
    EProgram: TFilenameEdit;
    Label44: TLabel;
    EProgParam: TEdit;
    Label45: TLabel;
    EWorkDir: TEdit;
    RGMethod: TRadioGroup;
    Label46: TLabel;
    MEnv: TMemo;
    Button5: TButton;
    GroupBox4: TGroupBox;
    Label47: TLabel;
    CBPriority: TComboBox;
    Label48: TLabel;
    CBShowMode: TComboBox;
    Label49: TLabel;
    EShellOp: TEdit;
    GroupBox5: TGroupBox;
    Label50: TLabel;
    SEWH: TRxSpinEdit;
    Label51: TLabel;
    SEWW: TRxSpinEdit;
    Label52: TLabel;
    SEWL: TRxSpinEdit;
    Label53: TLabel;
    SEWT: TRxSpinEdit;
    Label54: TLabel;
    EConsTitle: TEdit;
    Label55: TLabel;
    SECharsX: TRxSpinEdit;
    Label56: TLabel;
    SECharsY: TRxSpinEdit;
    GroupBox6: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    GroupBox7: TGroupBox;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    CheckBox16: TCheckBox;
    CheckBox17: TCheckBox;
    CheckBox18: TCheckBox;
    CBOnFinish: TCheckBox;
    CBOnTE: TCheckBox;
    CBWaitFinish: TCheckBox;
    Label57: TLabel;
    SETWI: TRxSpinEdit;
    Label58: TLabel;
    SETWT: TRxSpinEdit;
    Label59: TLabel;
    SETI: TRxSpinEdit;
    GroupBox8: TGroupBox;
    rPeriodComboEdit1: TrPeriodComboEdit;
    CBNeedPrefix: TCheckBox;
    GroupBox9: TGroupBox;
    rDLLloader1: TrDLLloader;
    Label60: TLabel;
    ELibName: TFilenameEdit;
    Button7: TButton;
    Label61: TLabel;
    MVersionInfo: TMemo;
    Label62: TLabel;
    EReqVer: TEdit;
    Label63: TLabel;
    MReqProcs: TMemo;
    PopupMenu2: TPopupMenu;
    Refresh2: TMenuItem;
    RefreshAll1: TMenuItem;
    ILSex: TImageList;
    TSDBTree: TTabSheet;
    TrDBTreeView1: TMenuItem;
    rDBTreeView1: TrDBTreeView;
    DSTree: TDataSource;
    Functions1: TMenuItem;
    TSFunc: TTabSheet;
    DateEdit: TDateEdit;
    Button8: TButton;
    LADS: TrLabel;
    Button9: TButton;
    LDOM: TrLabel;
    E1: TEdit;
    Button10: TButton;
    LFFIO: TrLabel;
    E2_1: TEdit;
    Button11: TButton;
    LCES: TrLabel;
    E2_2: TEdit;
    E2_3: TEdit;
    E3_1: TEdit;
    E3_3: TEdit;
    Button12: TButton;
    LST: TrLabel;
    E3_2: TRxSpinEdit;
    Button13: TButton;
    LDTSF: TrLabel;
    Button14: TButton;
    DateEdit1: TDateEdit;
    Number: TRxCalcEdit;
    E4_2: TRxSpinEdit;
    E4_4: TEdit;
    Button15: TButton;
    LF: TrLabel;
    E4_3: TRxSpinEdit;
    E5: TEdit;
    Button16: TButton;
    LCC: TrLabel;
    E6_1: TEdit;
    E6_2: TEdit;
    E6_3: TEdit;
    Button17: TButton;
    LCS: TrLabel;
    E7_1: TEdit;
    E7_2: TEdit;
    Button18: TButton;
    LPWD: TrLabel;
    Button19: TButton;
    LNIW: TrLabel;
    Button20: TButton;
    LFTSF: TrLabel;
    Button21: TButton;
    Number1: TRxCalcEdit;
    Button22: TButton;
    LSR: TrLabel;
    N1_2: TRxSpinEdit;
    N2_2: TRxSpinEdit;
    Button23: TButton;
    LIC: TrLabel;
    N2_3: TRxSpinEdit;
    N2_4: TRxSpinEdit;
    N2_1: TRxSpinEdit;
    ECheckFieldName: TEdit;
    Label67: TLabel;
    N12: TMenuItem;
    NCheck: TMenuItem;
    NCheckAll: TMenuItem;
    NUnCheckAll: TMenuItem;
    Label68: TLabel;
    CBChecked: TComboBox;
    Panel4: TPanel;
    rDBGrid1: TrDBGrid;
    PCheck: TPanel;
    TSRx: TTabSheet;
    GroupBox10: TGroupBox;
    DateEdit2: TDateEdit;
    Label69: TLabel;
    DEMin: TDateEdit;
    Label70: TLabel;
    DEMax: TDateEdit;
    Label71: TLabel;
    CBCalStyle: TComboBox;
    GroupBox11: TGroupBox;
    RxSpinEdit1: TRxSpinEdit;
    RxSpinButton1: TRxSpinButton;
    Label72: TLabel;
    CBBtnStyle: TComboBox;
    Label73: TLabel;
    CBSEStyle: TComboBox;
    GroupBox12: TGroupBox;
    RxCalcEdit1: TRxCalcEdit;
    Splitter2: TSplitter;
    rRecordGrid1: TrRecordGrid;
    Rx1: TMenuItem;
    CBDAB: TCheckBox;
    CBMinR: TCheckBox;
    CBMaxR: TCheckBox;
    CEMinVal: TRxCalcEdit;
    Label64: TLabel;
    Label65: TLabel;
    CEMaxVal: TRxCalcEdit;
    GroupBox13: TGroupBox;
    ColorComboBox1: TColorComboBox;
    CBAllColors: TCheckBox;
    GBOptions: TGroupBox;
    CheckBox19: TCheckBox;
    CheckBox20: TCheckBox;
    CheckBox21: TCheckBox;
    CBCheckOnExit: TCheckBox;
    RxSpinEdit2: TRxSpinEdit;
    Label66: TLabel;
    CBDecPlaceRound: TCheckBox;
    GroupBox14: TGroupBox;
    rImage1: TrImage;
    SEII: TRxSpinEdit;
    Label74: TLabel;
    CBSlide: TCheckBox;
    Label75: TLabel;
    SEInterval: TRxSpinEdit;
    Button24: TButton;
    Button25: TButton;
    Launcher2: TLauncher;
    CBFlatCheck: TCheckBox;
    Panel5: TPanel;
    CBNotSelectParent: TCheckBox;
    Button26: TButton;
    Label76: TLabel;
    CBDisableStyle: TComboBox;
    TSPlugins: TTabSheet;
    rPlugins1: TrPlugins;
    lbTypes: TListBox;
    lbNames: TListBox;
    lNames: TLabel;
    lTypes: TLabel;
    btByType: TButton;
    btByName: TButton;
    btSetup: TButton;
    rBitBtn3: TrBitBtn;
    PanelDate: TrLabel;
    GroupBox15: TGroupBox;
    CBMultiSelect: TCheckBox;
    CBSelectNode: TCheckBox;
    CBSelectChild: TCheckBox;
    CBCancel: TCheckBox;
    CBDefault: TCheckBox;
    procedure RGAlignmentClick(Sender: TObject);
    procedure RGBevelInnerClick(Sender: TObject);
    procedure RGBevelOuterClick(Sender: TObject);
    procedure CBBlinkClick(Sender: TObject);
    procedure CCBBottomColorChange(Sender: TObject);
    procedure CCBBlinkColorChange(Sender: TObject);
    procedure SESpeedChange(Sender: TObject);
    procedure CCBTopColorChange(Sender: TObject);
    procedure CBTransparentClick(Sender: TObject);
    procedure ECaptionChange(Sender: TObject);
    procedure CBBorderTransparentClick(Sender: TObject);
    procedure SEBorderWidthChange(Sender: TObject);
    procedure SEBevelWidthChange(Sender: TObject);
    procedure CCBColorChange(Sender: TObject);
    procedure RGLayoutClick(Sender: TObject);
    procedure CCBRTCChange(Sender: TObject);
    procedure SERTDChange(Sender: TObject);
    procedure CBTopClick(Sender: TObject);
    procedure CBBottomClick(Sender: TObject);
    procedure CCBRBCChange(Sender: TObject);
    procedure SERBDChange(Sender: TObject);
    procedure CBTransClick(Sender: TObject);
    procedure CBWWClick(Sender: TObject);
    procedure BFontClick(Sender: TObject);
    procedure FDApply(Sender: TObject; Wnd: HWND);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TrPageSetupDialog1Click(Sender: TObject);
    procedure TrLabel1Click(Sender: TObject);
    procedure AFindNextActiveChanged(Sender: TObject;
      DataLink: TFieldDataLink; var SetEnabled: Boolean);
    procedure AFindExecute(Sender: TObject);
    procedure CBGAutoSizeClick(Sender: TObject);
    procedure CBGAutoWidthClick(Sender: TObject);
    procedure rDBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure SEDefRowHeightChange(Sender: TObject);
    procedure CBGMultilineClick(Sender: TObject);
    procedure CBGDispBoolClick(Sender: TObject);
    procedure CBGDispImagesClick(Sender: TObject);
    procedure CBGDispMemoClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure TrBackground1Click(Sender: TObject);
    procedure CBStyleChange(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure EMessageChange(Sender: TObject);
    procedure ETitleMessageChange(Sender: TObject);
    procedure EUserNameChange(Sender: TObject);
    procedure ErrorHandler1ExtButtonClick(Sender: TObject);
    procedure EHCaptionChange(Sender: TObject);
    procedure EExtBtnCaptionChange(Sender: TObject);
    procedure CBEBVisibleChange(Sender: TObject);
    procedure EIniFileExit(Sender: TObject);
    procedure CBIniLocChange(Sender: TObject);
    procedure ELogFileExit(Sender: TObject);
    procedure CBLogLocChange(Sender: TObject);
    procedure CBSaveLogClick(Sender: TObject);
    procedure CBShowFormClick(Sender: TObject);
    procedure MDescExit(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure CBTableChange(Sender: TObject);
    procedure rBitBtn2Click(Sender: TObject);
    procedure rBitBtn1Click(Sender: TObject);
    procedure rDBGrid1Enter(Sender: TObject);
    procedure PCMainChange(Sender: TObject);
    procedure DBBBTestClick(Sender: TObject);
    procedure CBKindActionChange(Sender: TObject);
    procedure CBNFirstClick(Sender: TObject);
    procedure CBPFirstClick(Sender: TObject);
    procedure EProgramChange(Sender: TObject);
    procedure EProgParamChange(Sender: TObject);
    procedure EWorkDirChange(Sender: TObject);
    procedure MEnvExit(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure RGMethodClick(Sender: TObject);
    procedure CBPriorityChange(Sender: TObject);
    procedure CBShowModeChange(Sender: TObject);
    procedure EShellOpExit(Sender: TObject);
    procedure SEWHChange(Sender: TObject);
    procedure SEWWChange(Sender: TObject);
    procedure SEWLChange(Sender: TObject);
    procedure SEWTChange(Sender: TObject);
    procedure EConsTitleChange(Sender: TObject);
    procedure SECharsXChange(Sender: TObject);
    procedure SECharsYChange(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox9Click(Sender: TObject);
    procedure Launcher1Finished(Sender: TObject);
    procedure Launcher1TimeoutElapsed(Sender: TObject; WaitInit: Boolean);
    procedure SETWIChange(Sender: TObject);
    procedure SETWTChange(Sender: TObject);
    procedure SETIChange(Sender: TObject);
    procedure CBOnFinishClick(Sender: TObject);
    procedure CBOnTEClick(Sender: TObject);
    procedure CBNeedPrefixClick(Sender: TObject);
    procedure ELibNameChange(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure EReqVerChange(Sender: TObject);
    procedure MReqProcsExit(Sender: TObject);
    procedure RefreshAll1Click(Sender: TObject);
    procedure Refresh2Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure Button18Click(Sender: TObject);
    procedure Button19Click(Sender: TObject);
    procedure Button20Click(Sender: TObject);
    procedure Button21Click(Sender: TObject);
    procedure Button22Click(Sender: TObject);
    procedure Button23Click(Sender: TObject);
    procedure CBGRowSizingClick(Sender: TObject);
    procedure ECheckFieldNameChange(Sender: TObject);
    procedure NCheckClick(Sender: TObject);
    procedure NCheckAllClick(Sender: TObject);
    procedure NUnCheckAllClick(Sender: TObject);
    procedure CBCheckedChange(Sender: TObject);
    procedure rDBGrid1CheckListChange(Sender: TObject; Item: Variant;
      Action: TVarListAction);
    procedure CBEditingClick(Sender: TObject);
    procedure CBCalStyleChange(Sender: TObject);
    procedure DEMinChange(Sender: TObject);
    procedure DEMaxChange(Sender: TObject);
    procedure CBBtnStyleChange(Sender: TObject);
    procedure CBSEStyleChange(Sender: TObject);
    procedure CBDABClick(Sender: TObject);
    procedure CBMinRClick(Sender: TObject);
    procedure CBMaxRClick(Sender: TObject);
    procedure CEMinValChange(Sender: TObject);
    procedure CEMaxValChange(Sender: TObject);
    procedure CBAllColorsClick(Sender: TObject);
    procedure CheckBox20Click(Sender: TObject);
    procedure CBCheckOnExitClick(Sender: TObject);
    procedure CBDecPlaceRoundClick(Sender: TObject);
    procedure RxSpinEdit2Exit(Sender: TObject);
    procedure SEIIChange(Sender: TObject);
    procedure CBSlideClick(Sender: TObject);
    procedure SEIntervalChange(Sender: TObject);
    procedure Button24Click(Sender: TObject);
    procedure Button25Click(Sender: TObject);
    procedure CBFlatCheckClick(Sender: TObject);
    procedure CBNotSelectParentClick(Sender: TObject);
    procedure Button26Click(Sender: TObject);
    procedure CBDisableStyleChange(Sender: TObject);
    procedure btSetupClick(Sender: TObject);
    procedure btByTypeClick(Sender: TObject);
    procedure btByNameClick(Sender: TObject);
    procedure lbTypesClick(Sender: TObject);
    procedure rBitBtn3Click(Sender: TObject);
    procedure CBMultiSelectClick(Sender: TObject);
    procedure CBSelectNodeClick(Sender: TObject);
    procedure CBSelectChildClick(Sender: TObject);
    procedure CBWaitFinishClick(Sender: TObject);
    procedure CBCancelClick(Sender: TObject);
    procedure CBDefaultClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ChangeDBSource(DS: TDataSource);
  end;

var
  Form1: TForm1;
const
  ProgramKey = '\Software\Polaris\PolarisLibDemo';

implementation

{$R *.DFM}

procedure TForm1.ChangeDBSource(DS: TDataSource);
begin
  AFirst.DataSource := DS;
  ALast.DataSource := DS;
  AInsert.DataSource := DS;
  AEdit.DataSource := DS;
  ADelete.DataSource := DS;
  AView.DataSource := DS;
  ARefresh.DataSource := DS;
  AFind.DataSource := DS;
  AFindNext.DataSource := DS;
  rLocateDlg1.DataSource := DS;
end;

procedure TForm1.RGAlignmentClick(Sender: TObject);
begin
  rLabel1.Alignment := TAlignment(RGAlignment.ItemIndex);
end;

procedure TForm1.RGBevelInnerClick(Sender: TObject);
begin
  rLabel1.BevelInner := TPanelBevel(RGBevelInner.ItemIndex);
end;

procedure TForm1.RGBevelOuterClick(Sender: TObject);
begin
  rLabel1.BevelOuter := TPanelBevel(RGBevelOuter.ItemIndex);
end;

procedure TForm1.CBBlinkClick(Sender: TObject);
begin
  rLabel1.Blink := CBBlink.Checked;
end;

procedure TForm1.CCBBottomColorChange(Sender: TObject);
begin
  rLabel1.BlinkBottomColor := CCBBottomColor.ColorValue;
end;

procedure TForm1.CCBBlinkColorChange(Sender: TObject);
begin
  rLabel1.BlinkColor := CCBBlinkColor.ColorValue;
end;

procedure TForm1.SESpeedChange(Sender: TObject);
begin
  rLabel1.BlinkSpeed := SESpeed.AsInteger;
end;

procedure TForm1.CCBTopColorChange(Sender: TObject);
begin
  rLabel1.BlinkTopColor := CCBTopColor.ColorValue;
end;

procedure TForm1.CBTransparentClick(Sender: TObject);
begin
  rLabel1.BlinkTransparent := CBTransparent.Checked;
end;

procedure TForm1.ECaptionChange(Sender: TObject);
begin
  rLabel1.Caption := ECaption.Text;
end;

procedure TForm1.CBBorderTransparentClick(Sender: TObject);
begin
  rLabel1.BorderTransparent := CBBorderTransparent.Checked;
end;

procedure TForm1.SEBorderWidthChange(Sender: TObject);
begin
  rLabel1.BorderWidth := SEBorderWidth.AsInteger;
end;

procedure TForm1.SEBevelWidthChange(Sender: TObject);
begin
  rLabel1.BevelWidth := SEBevelWidth.AsInteger;
end;

procedure TForm1.CCBColorChange(Sender: TObject);
begin
  rLabel1.Color := CCBColor.ColorValue;
end;

procedure TForm1.RGLayoutClick(Sender: TObject);
begin
  rLabel1.Layout := TTextLayout(RGLayout.ItemIndex);
end;

procedure TForm1.CCBRTCChange(Sender: TObject);
begin
  rLabel1.RaisedTopColor := CCBRTC.ColorValue;
end;

procedure TForm1.SERTDChange(Sender: TObject);
begin
  rLabel1.RaisedTopDistance := SERTD.AsInteger;
end;

procedure TForm1.CBTopClick(Sender: TObject);
begin
  rLabel1.RaisedTop := CBTop.Checked;
end;

procedure TForm1.CBBottomClick(Sender: TObject);
begin
  rLabel1.RaisedBottom := CBBottom.Checked;
end;

procedure TForm1.CCBRBCChange(Sender: TObject);
begin
  rLabel1.RaisedBottomColor := CCBRBC.ColorValue;
end;

procedure TForm1.SERBDChange(Sender: TObject);
begin
  rLabel1.RaisedBottomDistance := SERBD.AsInteger;
end;

procedure TForm1.CBTransClick(Sender: TObject);
begin
  rLabel1.Transparent := CBTrans.Checked;
end;

procedure TForm1.CBWWClick(Sender: TObject);
begin
  rLabel1.WordWrap := CBWW.Checked;
end;

procedure TForm1.BFontClick(Sender: TObject);
begin
  FD.Font.Assign(rLabel1.Font);
  if FD.Execute then
    rLabel1.Font.Assign(FD.Font);
end;

procedure TForm1.FDApply(Sender: TObject; Wnd: HWND);
begin
  rLabel1.Font.Assign(FD.Font);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  ExecuteForm(TAboutBox.Create(Self));
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i,j : Integer;
  sl1 : TStringList;
begin
  SetCurrentDir(ExtractFilePath(Application.ExeName));
  ErrorHandler1.UserName := GetOSUser;
  Application.OnException := ErrorHandler1.AppException;
  PCMain.ActivePageIndex := 0;

  ECaption.Text := rLabel1.Caption;

  LoadToImage(hInstance, 'RTB_DB', rkBitmap, ILMenu);
  AFind.ImageIndex := ILMenu.Count;
  AFindNext.ImageIndex := ILMenu.Count+1;
  LoadToImage(hInstance,'RTB_FIND',rkBitmap,ILMenu);
  rDBGrid1.RegKey := ProgramKey;
  rBackground1.RegKey := ProgramKey;
  with DM1.rDBConnect1 do begin
    RegKey := ProgramKey;
    EAlias.Text := Alias;
    EUser.Text := User;
    EPassword.Text := Password;
  end;
  rPlugins1.RegKey := ProgramKey;

  LoadToImage(hInstance,'RTB_TREE',rkBitmap,ILTree);
  LoadToImage(hInstance, 'SEX', rkBitmap, ILSex);

  CBStyle.ItemIndex := 4;
  CBEBVisible.ItemIndex := 0;
  CBIniLoc.ItemIndex := 1;
  CBLogLoc.ItemIndex := 1;
  CBKindAction.ItemIndex := 0;
  CBPriority.ItemIndex := 1;
  CBShowMode.ItemIndex := 1;
  CBCalStyle.ItemIndex := 1;
  CBBtnStyle.ItemIndex := 0;
  CBSEStyle.ItemIndex := 1;
  rPeriodComboEdit1.AssignDate(Date, bdMonth, 0);
  DateEdit.Date := Date;
  CBChecked.ItemIndex := 0;
  CBDisableStyle.ItemIndex := 0;

  rPlugins1.PlugsPath := ExtractFilePath(Application.ExeName)+'Plugins';
  lbTypes.Items.Text := rPlugins1.GetPlugTypes;
  sl1 := TStringList.Create;
  for i := 0 to lbTypes.Items.Count-1 do begin
    sl1.Text := rPlugins1.GetPlugNames(lbTypes.Items.Strings[i]);
    for j := 0 to sl1.Count-1 do
      lbNames.Items.Add(sl1.Strings[j]);
  end;
  sl1.Free;
end;

procedure TForm1.TrPageSetupDialog1Click(Sender: TObject);
begin
  with TrPageSetupDialog.Create(Self) do
    try
      Execute;
    finally
      Free;
    end;
end;

procedure TForm1.TrLabel1Click(Sender: TObject);
begin
  PCMain.ActivePageIndex := TComponent(Sender).Tag;
end;

procedure TForm1.AFindNextActiveChanged(Sender: TObject;
  DataLink: TFieldDataLink; var SetEnabled: Boolean);
begin
  SetEnabled := rLocateDlg1.NextEnable;
end;

procedure TForm1.AFindExecute(Sender: TObject);
begin
  rLocateDlg1.Execute(TComponent(Sender).Tag=0);
end;

procedure TForm1.CBGAutoSizeClick(Sender: TObject);
begin
  rDBGrid1.GridAutoSize := CBGAutoSize.Checked;
end;

procedure TForm1.CBGAutoWidthClick(Sender: TObject);
begin
  rDBGrid1.GridAutoWidth := CBGAutoWidth.Checked;
end;

procedure TForm1.rDBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
  DataCol: Integer; Column: TColumn; State: TGridDrawState);
begin
  if Datacol = 0 then
    SEDefRowHeight.Value := rDBGrid1.DefaultRowHeight;
  if Assigned(Column) and Assigned(Column.Field) and
     (UpperCase(Column.FieldName) = 'SEX') then
    DrawImage(rDBGrid1.Canvas, Rect, ILSex,
              IIF(Column.Field.AsString='M', 0, IIF(Column.Field.AsString='F', 1, -1)));
end;

procedure TForm1.SEDefRowHeightChange(Sender: TObject);
begin
  rDBGrid1.DefaultRowHeight := SEDefRowHeight.AsInteger;
end;

procedure TForm1.CBGMultilineClick(Sender: TObject);
begin
  rDBGrid1.MultiLineTitles := CBGMultiline.Checked;
end;

procedure TForm1.CBGDispBoolClick(Sender: TObject);
begin
  rDBGrid1.DisplayBoolean := CBGDispBool.Checked;
end;

procedure TForm1.CBGDispImagesClick(Sender: TObject);
begin
  rDBGrid1.DisplayImages := CBGDispImages.Checked;
end;

procedure TForm1.CBGDispMemoClick(Sender: TObject);
begin
  rDBGrid1.DisplayMemo := CBGDispMemo.Checked;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if ActiveControl is TrDBGrid then TrDBGrid(ActiveControl).RunSetup
  else if Sender = Button1 then rDBGrid1.RunSetup;
end;

procedure TForm1.TrBackground1Click(Sender: TObject);
begin
  ExecuteForm(TFormBackGround.Create(Self));
end;

procedure TForm1.CBStyleChange(Sender: TObject);
begin
  ErrorHandler1.Style := TrEHStyle(CBStyle.ItemIndex);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  with OpenPictureDialog1 do
    if Execute then begin
      Image1.Picture.LoadFromFile(FileName);
      ErrorHandler1.Picture.Assign(Image1.Picture);
    end;
end;

procedure TForm1.EMessageChange(Sender: TObject);
begin
  ErrorHandler1.Message := EMessage.Text;
end;

procedure TForm1.ETitleMessageChange(Sender: TObject);
begin
  ErrorHandler1.TitleMessage := ETitleMessage.Text;
end;

procedure TForm1.EUserNameChange(Sender: TObject);
begin
  ErrorHandler1.UserName := EUserName.Text;
end;

procedure TForm1.ErrorHandler1ExtButtonClick(Sender: TObject);
begin
  rMsgBox('Extension button clicked successfully!!!',MB_OK);
end;

procedure TForm1.EHCaptionChange(Sender: TObject);
begin
  ErrorHandler1.Caption := EHCaption.Text;
end;

procedure TForm1.EExtBtnCaptionChange(Sender: TObject);
begin
  ErrorHandler1.ExtBtnCaption := EExtBtnCaption.Text;
end;

procedure TForm1.CBEBVisibleChange(Sender: TObject);
begin
  ErrorHandler1.ExtBtnVisible := TrEHExtBtn(CBEBVisible.ItemIndex);
end;

procedure TForm1.EIniFileExit(Sender: TObject);
begin
  ErrorHandler1.IniFile := EIniFile.Text;
end;

procedure TForm1.CBIniLocChange(Sender: TObject);
begin
  ErrorHandler1.IniLocation := TrFileLocation(CBIniLoc.ItemIndex);
end;

procedure TForm1.ELogFileExit(Sender: TObject);
begin
  ErrorHandler1.LogFile := ELogFile.Text;
end;

procedure TForm1.CBLogLocChange(Sender: TObject);
begin
  ErrorHandler1.LogLocation := TrFileLocation(CBLogLoc.ItemIndex);
end;

procedure TForm1.CBSaveLogClick(Sender: TObject);
begin
  ErrorHandler1.SaveLog := CBSaveLog.Checked;
end;

procedure TForm1.CBShowFormClick(Sender: TObject);
begin
  ErrorHandler1.ShowForm := CBShowForm.Checked;
end;

procedure TForm1.MDescExit(Sender: TObject);
begin
  ErrorHandler1.Description.Text := MDesc.Text;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 case RGExcept.ItemIndex of
   0: raise Exception.Create(EMessage.Text);
   1: raise EAnyError.CreateAny(ETitleMessage.Text, EMessage.Text, MDesc.Text);
   2: raise EDatabaseError.Create(EMessage.Text);
   3: raise EWin32Error.Create(EMessage.Text);
   4: with ErrorHandler1 do ShowMessage(Caption, TitleMessage, Message, Description.Text, Style);
 end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 try
   if DM1.Database1.Connected then begin
     DM1.Database1.Close;
     CBTable.Clear;
     Button4.Caption := 'Connect...';
   end else
     with DM1.rDBConnect1 do begin
       AutoLogon := CBAutoLogon.Checked;
       MaxAttempts := SEMaxAtt.AsInteger;
       AliasEnabled := CBAlias.Checked;
       UserEnabled := CBUser.Checked;
       Drivers := EDrivers.Text;
       Alias := EAlias.Text;
       User := EUser.Text;
       Password := EPassword.Text;
       if Connect then begin
         EAlias.Text := Alias;
         EUser.Text := User;
         EPassword.Text := Password;
         Button4.Caption := 'Disconnect';
         Session.GetTableNames('DBTest','',False,False,CBTable.Items);
         CBTable.ItemIndex := 0;
         CBTableChange(CBTable);
       end;
     end;
 finally
   Button6.Caption := Button4.Caption;
 end;
end;

procedure TForm1.CBTableChange(Sender: TObject);
begin
  with DM1.Table1 do begin
    Close;
    Filter := '';
    TableName := CBTable.Text;
    DBEditTest.DataField := '';
    DBNULLSBTest.DataField := '';
    DBNULLBBTest.DataField := '';
    Open;
    DBEditTest.DataField := Fields[0].FieldName;
    DBNULLSBTest.DataField := Fields[0].FieldName;
    DBNULLBBTest.DataField := Fields[0].FieldName;
    LTest.Caption := DBEditTest.DataField+':';
  end;
end;

procedure TForm1.rBitBtn2Click(Sender: TObject);
begin
  DM1.Table1.Filter := EFilter.Text;
end;

procedure TForm1.rBitBtn1Click(Sender: TObject);
begin
  DM1.rCloneTable1.Close;
  DM1.rCloneTable1.Open;
end;

procedure TForm1.rDBGrid1Enter(Sender: TObject);
begin
  ChangeDBSource(TDBGrid(Sender).DataSource);
end;

procedure TForm1.PCMainChange(Sender: TObject);
begin
  if PCMain.ActivePage = TSData then
    ChangeDBSource(DSGrid)
  else if (PCMain.ActivePage = TSBDE) or (PCMain.ActivePage = TSButtons) then begin
    Session.GetAliasNames(EAlias.Items);
    Session.GetDriverNames(EDrivers.Items);
    ChangeDBSource(DSCloneSrc);
  end else if PCMain.ActivePage = TSDBTree then
    ChangeDBSource(DSTree)
  else
    ChangeDBSource(nil);
end;

procedure TForm1.DBBBTestClick(Sender: TObject);
begin
  if ATest.Kind = tbaCustom then
    rMsgBox('Button clicked successfully!!!',MB_OK);
end;

procedure TForm1.CBKindActionChange(Sender: TObject);
var
  i: Integer;
begin
  DBSBTest.KindAction := TrDBAction(CBKindAction.ItemIndex);
  DBBBTest.KindAction := DBSBTest.KindAction;
  ATest.Kind := DBSBTest.KindAction;
  with GBNeg do
    for i := 0 to ControlCount-1 do
      if Controls[i] is TCheckBox then
        TCheckBox(Controls[i]).Checked :=
          TrDBOption(TCheckBox(Controls[i]).Tag) in DBSBTest.Negative;
  with GBPos do
    for i := 0 to ControlCount-1 do
      if Controls[i] is TCheckBox then
        TCheckBox(Controls[i]).Checked :=
          TrDBOption(TCheckBox(Controls[i]).Tag) in DBSBTest.Positive;
end;

procedure TForm1.CBNFirstClick(Sender: TObject);
begin
  if TCheckBox(Sender).Checked then
    DBSBTest.Negative := DBSBTest.Negative + [TrDBOption(TCheckBox(Sender).Tag)]
  else
    DBSBTest.Negative := DBSBTest.Negative - [TrDBOption(TCheckBox(Sender).Tag)];
  DBBBTest.Negative := DBSBTest.Negative;
  ATest.Negative := DBSBTest.Negative;
end;

procedure TForm1.CBPFirstClick(Sender: TObject);
begin
  if TCheckBox(Sender).Checked then
    DBSBTest.Positive := DBSBTest.Positive + [TrDBOption(TCheckBox(Sender).Tag)]
  else
    DBSBTest.Positive := DBSBTest.Positive - [TrDBOption(TCheckBox(Sender).Tag)];
  DBBBTest.Positive := DBSBTest.Positive;
  ATest.Positive := DBSBTest.Positive;
end;

procedure TForm1.EProgramChange(Sender: TObject);
begin
  Launcher1.ProgramName := EProgram.Text;
end;

procedure TForm1.EProgParamChange(Sender: TObject);
begin
  Launcher1.Parameters := EProgParam.Text;
end;

procedure TForm1.EWorkDirChange(Sender: TObject);
begin
  Launcher1.WorkDir := EWorkDir.Text;
end;

procedure TForm1.MEnvExit(Sender: TObject);
begin
  Launcher1.Environment.Text := MEnv.Text;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Launcher1.Launch;
end;

procedure TForm1.RGMethodClick(Sender: TObject);
begin
  Launcher1.LaunchMethod := TrLaunchMethod(RGMethod.ItemIndex);
end;

procedure TForm1.CBPriorityChange(Sender: TObject);
begin
  Launcher1.Priority := TrPriorityClass(CBPriority.ItemIndex);
end;

procedure TForm1.CBShowModeChange(Sender: TObject);
begin
  Launcher1.ShowMode := TShowMode(CBShowMode.ItemIndex);
end;

procedure TForm1.EShellOpExit(Sender: TObject);
begin
  Launcher1.ShellOperation := EShellOp.Text;
end;

procedure TForm1.SEWHChange(Sender: TObject);
begin
  Launcher1.WindowHeight := SEWH.AsInteger;
end;

procedure TForm1.SEWWChange(Sender: TObject);
begin
  Launcher1.WindowWidth := SEWW.AsInteger;
end;

procedure TForm1.SEWLChange(Sender: TObject);
begin
  Launcher1.WindowLeft := SEWL.AsInteger;
end;

procedure TForm1.SEWTChange(Sender: TObject);
begin
  Launcher1.WindowTop := SEWT.AsInteger;
end;

procedure TForm1.EConsTitleChange(Sender: TObject);
begin
  Launcher1.ConsoleTitle := EConsTitle.Text;
end;

procedure TForm1.SECharsXChange(Sender: TObject);
begin
  Launcher1.ConsoleCharsX := SECharsX.AsInteger;
end;

procedure TForm1.SECharsYChange(Sender: TObject);
begin
  Launcher1.ConsoleCharsY := SECharsY.AsInteger;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  with Launcher1 do
    if TCheckBox(Sender).Checked then
      ConsoleFillAttributes := ConsoleFillAttributes + [TrFillAttribute(TCheckBox(Sender).Tag)]
    else
      ConsoleFillAttributes := ConsoleFillAttributes - [TrFillAttribute(TCheckBox(Sender).Tag)];
end;

procedure TForm1.CheckBox9Click(Sender: TObject);
begin
  with Launcher1 do
    if TCheckBox(Sender).Checked then
      StartupFlags := StartupFlags + [TrStartupFlag(TCheckBox(Sender).Tag)]
    else
      StartupFlags := StartupFlags - [TrStartupFlag(TCheckBox(Sender).Tag)];
end;

procedure TForm1.Launcher1Finished(Sender: TObject);
begin
  rMsgBox('Running of '+AnsiUpperCase(Launcher1.ProgramName)+' finished!!!',MB_OK);
end;

procedure TForm1.Launcher1TimeoutElapsed(Sender: TObject;
  WaitInit: Boolean);
begin
  if WaitInit then
    rMsgBox('Waiting time for '+IIF(WaitInit, 'starting', 'finishing')+
            ' of '+AnsiUpperCase(Launcher1.ProgramName)+' elapsed!!!',MB_OK);
  if CBWaitFinish.Checked then Enabled := True;
end;

procedure TForm1.SETWIChange(Sender: TObject);
begin
  Launcher1.TimeoutWaitInit := SETWI.AsInteger;
end;

procedure TForm1.SETWTChange(Sender: TObject);
begin
  Launcher1.TimeoutWaitTerminate := SETWT.AsInteger;
end;

procedure TForm1.SETIChange(Sender: TObject);
begin
  Launcher1.TimerInterval := SETI.AsInteger;
end;

procedure TForm1.CBOnFinishClick(Sender: TObject);
begin
  if CBOnFinish.Checked then
    Launcher1.OnFinished := Launcher1Finished
  else
    Launcher1.OnFinished := nil;
end;

procedure TForm1.CBOnTEClick(Sender: TObject);
begin
  if CBOnTE.Checked then
    Launcher1.OnTimeoutElapsed := Launcher1TimeoutElapsed
  else
    Launcher1.OnTimeoutElapsed := nil;
end;

procedure TForm1.CBNeedPrefixClick(Sender: TObject);
begin
  rPeriodComboEdit1.NeedPrefix := CBNeedPrefix.Checked;
end;

procedure TForm1.ELibNameChange(Sender: TObject);
begin
  rDLLloader1.LibraryName := ELibName.Text;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  with rDLLloader1 do
    if Active then begin
      Close;
      MVersionInfo.Clear;
      Button7.Caption := '!!! Open !!!';
    end else begin
      Open;
      Button7.Caption := 'Close';
      MVersionInfo.Lines.Assign(VersionInfo);
    end;
end;

procedure TForm1.EReqVerChange(Sender: TObject);
begin
  rDLLloader1.RequiredVersion := EReqVer.Text;
end;

procedure TForm1.MReqProcsExit(Sender: TObject);
begin
  rDLLloader1.RequiredProcs.Assign(MReqProcs.Lines);
end;

procedure TForm1.RefreshAll1Click(Sender: TObject);
begin
  DictionaryMgr1.Refresh;
end;

procedure TForm1.Refresh2Click(Sender: TObject);
begin
  with DictionaryMgr1 do RefreshItem(ActiveItem);
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  LADS.Caption := AdaptedDateStr(DateEdit.Date);
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  LDOM.Caption := IntToStr(DaysOfMonth(DateEdit.Date));
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
  LFFIO.Caption := FormatFIO(E1.Text);
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
  LCES.Caption := ChangeEndStr(E2_1.Text,E2_2.Text,E2_3.Text);
end;

procedure TForm1.Button12Click(Sender: TObject);
begin
  LST.Caption := StrTrunc(E3_1.Text,E3_2.AsInteger,E3_3.Text);
end;

procedure TForm1.Button13Click(Sender: TObject);
begin
  LDTSF.Caption := DateToStrFix(DateEdit.Date);
end;

procedure TForm1.Button14Click(Sender: TObject);
begin
  DateEdit1.Date := StrToDateFix(LDTSF.Caption);
end;

procedure TForm1.Button15Click(Sender: TObject);
begin
  LF.Caption := Stuff(E3_1.Text,E4_2.AsInteger,E4_3.AsInteger,E4_4.Text);
end;

procedure TForm1.Button16Click(Sender: TObject);
begin
  LCC.Caption := ConvertCodes(E5.Text);
end;

procedure TForm1.Button17Click(Sender: TObject);
begin
  LCS.Caption := ConvertSymbols(E6_1.Text,E6_2.Text,E6_3.Text);
end;

procedure TForm1.Button18Click(Sender: TObject);
begin
  LPWD.Caption := IntToStr(PosWordDelims(E7_2.Text,E7_1.Text,[',']));
end;

procedure TForm1.Button19Click(Sender: TObject);
begin
  LNIW.Caption := NumInWords(Number.Value, gMale);
end;

procedure TForm1.Button20Click(Sender: TObject);
begin
  LFTSF.Caption := FloatToStrFix(Number.Value);
end;

procedure TForm1.Button21Click(Sender: TObject);
begin
  Number1.Value := StrToFloatFix(LFTSF.Caption);
end;

procedure TForm1.Button22Click(Sender: TObject);
begin
  LSR.Caption := FloatToStr(SoftRound(Number.Value, N1_2.AsInteger));
end;

procedure TForm1.Button23Click(Sender: TObject);
var
  i: Integer;
begin
  i := N2_1.AsInteger;
  LIC.Caption := FloatToStr(IncCycle(i, N2_2.AsInteger, N2_3.AsInteger, N2_4.AsInteger));
  N2_1.Value := i;
end;

procedure TForm1.CBGRowSizingClick(Sender: TObject);
begin
  rDBGrid1.RowSizingAllowed := CBGRowSizing.Checked
end;

procedure TForm1.ECheckFieldNameChange(Sender: TObject);
begin
  rDBGrid1.CheckFieldName := ECheckFieldName.Text;
end;

procedure TForm1.NCheckClick(Sender: TObject);
begin
  rDBGrid1.DoCheck;
end;

procedure TForm1.NCheckAllClick(Sender: TObject);
begin
  rDBGrid1.CheckAll(clmCheck);
end;

procedure TForm1.NUnCheckAllClick(Sender: TObject);
begin
  rDBGrid1.CheckList.Clear;
end;

procedure TForm1.CBCheckedChange(Sender: TObject);
begin
  Case CBChecked.ItemIndex of
    0: rDBGrid1.CheckType := csNone;
    1: rDBGrid1.CheckType := csCheck;
    2: rDBGrid1.CheckType := csRadio;
  end;
  if CBChecked.ItemIndex = 0 then PCheck.Caption := EmptyStr;
end;

procedure TForm1.rDBGrid1CheckListChange(Sender: TObject; Item: Variant;
  Action: TVarListAction);
begin
  PCheck.Caption := Format('Checked %d records', [rDBGrid1.CheckList.Count])
end;

procedure TForm1.CBEditingClick(Sender: TObject);
begin
  rDBGrid1.ReadOnly := CBEditing.Checked;
end;

procedure TForm1.CBCalStyleChange(Sender: TObject);
begin
  DateEdit2.CalendarStyle := TCalendarStyle(CBCalStyle.ItemIndex);
end;

procedure TForm1.DEMinChange(Sender: TObject);
begin
  DateEdit2.MinDate := DEMin.Date;      
  DEMax.Date := DateEdit2.MaxDate;
end;

procedure TForm1.DEMaxChange(Sender: TObject);
begin
  DateEdit2.MaxDate := DEMax.Date;
  DEMin.Date := DateEdit2.MinDate;
end;

procedure TForm1.CBBtnStyleChange(Sender: TObject);
begin
  RxSpinButton1.ButtonStyle := TrSpinButtonStyle(CBBtnStyle.ItemIndex);
end;

procedure TForm1.CBSEStyleChange(Sender: TObject);
begin
  RxSpinEdit1.ButtonKind := TSpinButtonKind(CBSEStyle.ItemIndex);
end;

procedure TForm1.CBDABClick(Sender: TObject);
begin
  DateEdit2.DateAutoBetween := CBDAB.Checked;
end;

procedure TForm1.CBMinRClick(Sender: TObject);
begin
  RxSpinEdit1.CheckMinValue := CBMinR.Checked;
  CBMinR.Checked := RxSpinEdit1.CheckMinValue;
end;

procedure TForm1.CBMaxRClick(Sender: TObject);
begin
  RxSpinEdit1.CheckMaxValue := CBMaxR.Checked;
  CBMaxR.Checked := RxSpinEdit1.CheckMaxValue;
end;

procedure TForm1.CEMinValChange(Sender: TObject);
begin
  RxSpinEdit1.MinValue := CEMinVal.Value;
  CBMinR.Checked := RxSpinEdit1.CheckMinValue;
  CBMaxR.Checked := RxSpinEdit1.CheckMaxValue;
end;

procedure TForm1.CEMaxValChange(Sender: TObject);
begin
  RxSpinEdit1.MaxValue := CEMaxVal.Value;
  CBMinR.Checked := RxSpinEdit1.CheckMinValue;
  CBMaxR.Checked := RxSpinEdit1.CheckMaxValue;
end;

procedure TForm1.CBAllColorsClick(Sender: TObject);
begin
  ColorComboBox1.AllColors := CBAllColors.Checked;
end;

procedure TForm1.CheckBox20Click(Sender: TObject);
begin
  if TCheckBox(Sender).Checked then
    ColorComboBox1.Options := ColorComboBox1.Options + [TColorComboOption(TCheckBox(Sender).Tag)]
  else
    ColorComboBox1.Options := ColorComboBox1.Options - [TColorComboOption(TCheckBox(Sender).Tag)];
end;

procedure TForm1.CBCheckOnExitClick(Sender: TObject);
begin
  RxSpinEdit1.CheckOnExit := CBCheckOnExit.Checked;
end;

procedure TForm1.CBDecPlaceRoundClick(Sender: TObject);
begin
  RxCalcEdit1.DecimalPlaceRound := CBDecPlaceRound.Checked;
end;

procedure TForm1.RxSpinEdit2Exit(Sender: TObject);
begin
  RxCalcEdit1.DecimalPlaces := RxSpinEdit2.AsInteger;
end;

procedure TForm1.SEIIChange(Sender: TObject);
begin
  rImage1.ImageIndex := SEII.AsInteger;
end;

procedure TForm1.CBSlideClick(Sender: TObject);
begin
  rImage1.SlideShow := CBSlide.Checked;
end;

procedure TForm1.SEIntervalChange(Sender: TObject);
begin
  rImage1.Interval := SEInterval.AsInteger;
end;

procedure TForm1.Button24Click(Sender: TObject);
begin
  with OpenPictureDialog1 do
    if Execute then
      rImage1.DefPicture.LoadFromFile(FileName);
end;

procedure TForm1.Button25Click(Sender: TObject);
begin
  Launcher2.ProgramName := EProgram.FileName;
  Launcher2.Launch;
end;

procedure TForm1.CBFlatCheckClick(Sender: TObject);
begin
  rDBGrid1.FlatCheck := CBFlatCheck.Checked;
end;

procedure TForm1.CBNotSelectParentClick(Sender: TObject);
begin
  rDBTreeView1.NotSelectParent := CBNotSelectParent.Checked;
end;

procedure TForm1.Button26Click(Sender: TObject);
begin
  with rDBTreeView1 do Enabled := not Enabled;
  with Button26 do
    if rDBTreeView1.Enabled then Caption := 'Disable'
    else Caption := 'Enable';
end;

procedure TForm1.CBDisableStyleChange(Sender: TObject);
begin
  rDBTreeView1.DisableStyle := TrTreeDisableStyle(CBDisableStyle.ItemIndex);
end;

procedure TForm1.btSetupClick(Sender: TObject);
begin
  SetupPlugins(rPlugins1);
end;

procedure TForm1.btByTypeClick(Sender: TObject);
var
  rslt : String;
  i : Integer;
begin
  for i := 0 to lbTypes.Items.Count-1 do
    if lbTypes.Selected[i] then begin
      rslt := rPlugins1.ExecutePlugin(
        '',lbTypes.Items.Strings[i],
        'It''s working !!!',
        '','');
      if rslt <> 'OK' then
        raise Exception.Create('It''s not working !!!'#13+rslt);
    end;
end;

procedure TForm1.btByNameClick(Sender: TObject);
var
  rslt : String;
  i : Integer;
begin
  for i := 0 to lbNames.Items.Count-1 do
    if lbNames.Selected[i] then begin
      rslt := rPlugins1.ExecutePlugin(
        lbNames.Items.Strings[i],'',
        'It''s working !!!',
        '','');
      if rslt <> 'OK' then
        raise Exception.Create('It''s not working !!!'#13+rslt);
    end;
end;

procedure TForm1.lbTypesClick(Sender: TObject);
var
  i : Integer;
begin
  for i := 0 to lbTypes.Items.Count-1 do
    if lbTypes.Selected[i] then
      lbNames.Items.Text := rPlugins1.GetPlugNames(lbTypes.Items.Strings[i]);
end;

procedure TForm1.rBitBtn3Click(Sender: TObject);
var
  Period: TrPeriod;
begin
  Period := TrPeriod.Create;
  with Period do
    try
      AssignDate(SysUtils.Date, bdDay, 0);
      if EditPeriod(Period) then
        PanelDate.Caption := GetName(CBNeedPrefix.Checked);
    finally
      Free;
    end;
end;

procedure TForm1.CBMultiSelectClick(Sender: TObject);
begin
  rDBTreeView1.MultiSelect.Enabled := CBMultiSelect.Enabled;
end;

procedure TForm1.CBSelectNodeClick(Sender: TObject);
begin
  with rDBTreeView1.MultiSelect do
    if CBSelectNode.Checked then
      ParentOptions := ParentOptions + [tpoSelectNode]
    else
      ParentOptions := ParentOptions - [tpoSelectNode];
end;

procedure TForm1.CBSelectChildClick(Sender: TObject);
begin
  with rDBTreeView1.MultiSelect do
    if CBSelectChild.Checked then
      ParentOptions := ParentOptions + [tpoSelectChild]
    else
      ParentOptions := ParentOptions - [tpoSelectChild];
end;

procedure TForm1.CBWaitFinishClick(Sender: TObject);
begin
  Launcher1.WaitTerminate := CBWaitFinish.Checked;
end;

procedure TForm1.CBCancelClick(Sender: TObject);
begin
  ErrorHandler1.Cancel := CBCancel.Checked;
end;

procedure TForm1.CBDefaultClick(Sender: TObject);
begin
  ErrorHandler1.Default := CBDefault.Checked;
end;

initialization
  TwoDigitYearCenturyWindow := 50;
  IsMultiThread := True;
end.

